// Copyright 2022 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// ** This file is automatically generated by gapic-generator-typescript. **
// ** https://github.com/googleapis/gapic-generator-typescript **
// ** All changes to this file may be overwritten. **



'use strict';

function main(completionConfig) {
  // [START retail_v2alpha_generated_CatalogService_UpdateCompletionConfig_async]
  /**
   * This snippet has been automatically generated and should be regarded as a code template only.
   * It will require modifications to work.
   * It may require correct/in-range values for request initialization.
   * TODO(developer): Uncomment these variables before running the sample.
   */
  /**
   *  Required. The
   *  CompletionConfig google.cloud.retail.v2alpha.CompletionConfig  to update.
   *  If the caller does not have permission to update the
   *  CompletionConfig google.cloud.retail.v2alpha.CompletionConfig, then a
   *  PERMISSION_DENIED error is returned.
   *  If the CompletionConfig google.cloud.retail.v2alpha.CompletionConfig  to
   *  update does not exist, a NOT_FOUND error is returned.
   */
  // const completionConfig = {}
  /**
   *  Indicates which fields in the provided
   *  CompletionConfig google.cloud.retail.v2alpha.CompletionConfig  to update.
   *  The following are the only supported fields:
   *  * CompletionConfig.matching_order google.cloud.retail.v2alpha.CompletionConfig.matching_order 
   *  * CompletionConfig.max_suggestions google.cloud.retail.v2alpha.CompletionConfig.max_suggestions 
   *  * CompletionConfig.min_prefix_length google.cloud.retail.v2alpha.CompletionConfig.min_prefix_length 
   *  * CompletionConfig.auto_learning google.cloud.retail.v2alpha.CompletionConfig.auto_learning 
   *  If not set, all supported fields are updated.
   */
  // const updateMask = {}

  // Imports the Retail library
  const {CatalogServiceClient} = require('@google-cloud/retail').v2alpha;

  // Instantiates a client
  const retailClient = new CatalogServiceClient();

  async function callUpdateCompletionConfig() {
    // Construct request
    const request = {
      completionConfig,
    };

    // Run request
    const response = await retailClient.updateCompletionConfig(request);
    console.log(response);
  }

  callUpdateCompletionConfig();
  // [END retail_v2alpha_generated_CatalogService_UpdateCompletionConfig_async]
}

process.on('unhandledRejection', err => {
  console.error(err.message);
  process.exitCode = 1;
});
main(...process.argv.slice(2));
